library IEEE,STD;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_unsigned.ALL;

use STD.textio.ALL;
use IEEE.std_logic_textio.ALL;

entity t_I2S_CONV3_RTL is
end t_I2S_CONV3_RTL;

architecture SIM of t_I2S_CONV3_RTL is

component I2S_CONV3_RTL
   port (
      MCLK    : in std_logic;
      SCLK    : in std_logic;
      LRCK    : in std_logic;
      SDATA   : in std_logic;
      SPDIF   : out std_logic
   );
end component ;

constant   MCLK_CYCLE    : TIME := 44 ns;
constant   SCLK_CYCLE    : TIME := 352 ns;
file       INV_PCM       : text;

   signal  MCLK   : std_logic;
   signal  SCLK   : std_logic;
   signal  LRCK   : std_logic;
   signal  SDATA  : std_logic;
   signal  SPDIF  : std_logic;
   signal  pdata  : std_logic_vector(63 downto 0);

begin

   u0:I2S_CONV3_RTL port map (
   MCLK => MCLK,
   SCLK => SCLK,
   LRCK => LRCK,
   SDATA => SDATA,
   SPDIF => SPDIF
   );

    process
    begin
       MCLK <= '1';
       wait for MCLK_CYCLE/2;
       MCLK <= '0';
       wait for MCLK_CYCLE/2;
    end process;

    process
    begin
       SCLK <= '0';
       wait for SCLK_CYCLE/2;
       SCLK <= '1';
       wait for SCLK_CYCLE/2;
    end process;

    process
    begin
       LRCK <= '1';
       wait for SCLK_CYCLE*32;
       LRCK <= '0';
       wait for SCLK_CYCLE*32;
    end process;

--   process(SCLK)
--   variable Li : line;
--   variable Di : std_logic_vector(63 downto 0);
--   variable seed : std_logic_vector(63 downto 0);
--   begin
--      if (LRCK'event and LRCK='0') then		-- falling edge of LRCK
--         readline(INV_PCM, Li);
--         hread(Li, Di);
--         seed := Di;
--      elsif (SCLK'event and SCLK='1') then
--         seed := seed(62 downto 0) & '0';
--         pdata <= seed;
--      end if;
--   end process;

   process
      variable Li : line;
      variable Di : std_logic_vector(63 downto 0);
      variable seed : std_logic_vector(63 downto 0);
      variable num_sclk : integer;
   begin

      file_open(INV_PCM, "seed.txt", read_mode);

      while not endfile(INV_PCM) loop
         wait until falling_edge(LRCK);
         readline(INV_PCM, Li);
         hread(Li, Di);
         seed := Di;
         num_sclk := 0;

         while(num_sclk < 64) loop
            wait until rising_edge(SCLK);
            seed := seed(62 downto 0) & '0';
            pdata <= seed;
            num_sclk := num_sclk + 1;
         end loop;

      end loop;

      file_close(INV_PCM);

      wait;
   end process;

   process(SCLK)
   begin
      if (SCLK'event and SCLK='0') then		-- <==== falling edge !!!
         SDATA <= pdata(63);
      end if;
   end process;

end SIM;
